'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = DateTimeInput;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ReadOnlyInput = require('./ReadOnlyInput');

var _ReadOnlyInput2 = _interopRequireDefault(_ReadOnlyInput);

var _pathHelpers = require('../helpers/pathHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * This is currently a read-only input.
 */

var propTypes = {
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType, // eslint-disable-line react/no-unused-prop-types
  subpath: _pathHelpers.pathPropType, // eslint-disable-line react/no-unused-prop-types
  value: _propTypes2.default.string,
  formatValue: _propTypes2.default.func
};

var defaultProps = {
  readOnly: true
};

function DateTimeInput(props) {
  var name = props.name,
      value = props.value,
      formatValue = props.formatValue;


  return _react2.default.createElement(_ReadOnlyInput2.default, {
    name: name,
    value: formatValue ? formatValue(value) : value
  });
}

DateTimeInput.propTypes = propTypes;
DateTimeInput.defaultProps = defaultProps;