'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _LineInput = require('./LineInput');

var _LineInput2 = _interopRequireDefault(_LineInput);

var _pathHelpers = require('../helpers/pathHelpers');

var _FileInput = require('../../styles/cspace-input/FileInput.css');

var _FileInput2 = _interopRequireDefault(_FileInput);

var _MiniButton = require('../../styles/cspace-input/MiniButton.css');

var _MiniButton2 = _interopRequireDefault(_MiniButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global File */

var fileListToArray = function fileListToArray(fileList) {
  var fileArray = [];

  for (var i = 0; i < fileList.length; i += 1) {
    fileArray.push(fileList[i]);
  }

  return fileArray;
};

var propTypes = {
  chooseButtonLabel: _propTypes2.default.string,
  name: _propTypes2.default.string,
  /* eslint-disable react/no-unused-prop-types */
  parentPath: _pathHelpers.pathPropType,
  subpath: _pathHelpers.pathPropType,
  /* eslint-enable react/no-unused-prop-types */
  value: _propTypes2.default.arrayOf(_propTypes2.default.instanceOf(File)),
  readOnly: _propTypes2.default.bool,
  formatFileInfo: _propTypes2.default.func,
  onCommit: _propTypes2.default.func
};

var defaultProps = {
  chooseButtonLabel: 'Select…',
  formatFileInfo: function formatFileInfo(name, type, size) {
    return name + ' (' + type + ', ' + size + ' bytes)';
  }
};

var FileInput = function (_Component) {
  _inherits(FileInput, _Component);

  function FileInput(props) {
    _classCallCheck(this, FileInput);

    var _this = _possibleConstructorReturn(this, (FileInput.__proto__ || Object.getPrototypeOf(FileInput)).call(this, props));

    _this.handleChooseButtonClick = _this.handleChooseButtonClick.bind(_this);
    _this.handleDragEnter = _this.handleDragEnter.bind(_this);
    _this.handleDragLeave = _this.handleDragLeave.bind(_this);
    _this.handleDragOver = _this.handleDragOver.bind(_this);
    _this.handleDrop = _this.handleDrop.bind(_this);
    _this.handleFileInputChange = _this.handleFileInputChange.bind(_this);
    _this.handleFileInputRef = _this.handleFileInputRef.bind(_this);

    _this.state = {
      isDraggedOver: false
    };
    return _this;
  }

  _createClass(FileInput, [{
    key: 'handleChooseButtonClick',
    value: function handleChooseButtonClick() {
      if (this.fileInput) {
        this.fileInput.click();
      }
    }
  }, {
    key: 'handleDragEnter',
    value: function handleDragEnter(event) {
      event.preventDefault();
      event.stopPropagation();

      this.setState({
        isDraggedOver: true
      });
    }
  }, {
    key: 'handleDragLeave',
    value: function handleDragLeave(event) {
      event.preventDefault();
      event.stopPropagation();

      this.setState({
        isDraggedOver: false
      });
    }

    // eslint-disable-next-line class-methods-use-this

  }, {
    key: 'handleDragOver',
    value: function handleDragOver(event) {
      event.preventDefault();
      event.stopPropagation();
    }
  }, {
    key: 'handleDrop',
    value: function handleDrop(event) {
      var onCommit = this.props.onCommit;


      event.preventDefault();
      event.stopPropagation();

      var files = event.dataTransfer.files;

      if (files && files.length > 0 && onCommit) {
        onCommit((0, _pathHelpers.getPath)(this.props), fileListToArray(files));
      }

      this.setState({
        isDraggedOver: false
      });
    }
  }, {
    key: 'handleFileInputChange',
    value: function handleFileInputChange(event) {
      var input = event.target;

      var onCommit = this.props.onCommit;


      if (onCommit) {
        onCommit((0, _pathHelpers.getPath)(this.props), fileListToArray(input.files));
      }
    }
  }, {
    key: 'handleFileInputRef',
    value: function handleFileInputRef(ref) {
      this.fileInput = ref;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          chooseButtonLabel = _props.chooseButtonLabel,
          name = _props.name,
          value = _props.value,
          readOnly = _props.readOnly,
          formatFileInfo = _props.formatFileInfo;


      if (readOnly) {
        return _react2.default.createElement(_LineInput2.default, { readOnly: true });
      }

      var isDraggedOver = this.state.isDraggedOver;


      var selectedFileDescription = null;

      if (value && value.length > 0) {
        var file = value[0];

        selectedFileDescription = formatFileInfo(file.name, file.type, file.size);
      }

      var className = isDraggedOver ? _FileInput2.default.dragOver : _FileInput2.default.normal;

      return (
        // Allow click/drag/drop events on the file info div.
        /* eslint-disable jsx-a11y/no-static-element-interactions */
        _react2.default.createElement(
          'div',
          {
            className: className
          },
          _react2.default.createElement('input', {
            name: name,
            ref: this.handleFileInputRef,
            tabIndex: '-1',
            type: 'file',
            onChange: this.handleFileInputChange
          }),
          _react2.default.createElement(
            'button',
            {
              className: _MiniButton2.default.common,
              type: 'button',
              onClick: this.handleChooseButtonClick
            },
            chooseButtonLabel
          ),
          _react2.default.createElement(
            'div',
            {
              onClick: this.handleChooseButtonClick,
              onDragEnter: this.handleDragEnter,
              onDragLeave: this.handleDragLeave,
              onDragOver: this.handleDragOver,
              onDrop: this.handleDrop
            },
            selectedFileDescription
          )
        )
        /* eslint-enable jsx-a11y/no-static-element-interactions */

      );
    }
  }]);

  return FileInput;
}(_react.Component);

exports.default = FileInput;


FileInput.propTypes = propTypes;
FileInput.defaultProps = defaultProps;