'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextInput = require('./TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

var _DropdownMenuInput = require('./DropdownMenuInput');

var _DropdownMenuInput2 = _interopRequireDefault(_DropdownMenuInput);

var _FileInput = require('./FileInput');

var _FileInput2 = _interopRequireDefault(_FileInput);

var _changeable = require('../enhancers/changeable');

var _changeable2 = _interopRequireDefault(_changeable);

var _committable = require('../enhancers/committable');

var _committable2 = _interopRequireDefault(_committable);

var _labelable = require('../enhancers/labelable');

var _labelable2 = _interopRequireDefault(_labelable);

var _pathHelpers = require('../helpers/pathHelpers');

var _UploadInput = require('../../styles/cspace-input/UploadInput.css');

var _UploadInput2 = _interopRequireDefault(_UploadInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global File */

var DropdownMenuInput = (0, _labelable2.default)(_DropdownMenuInput2.default);
var TextInput = (0, _labelable2.default)((0, _committable2.default)((0, _changeable2.default)(_TextInput2.default)));
var FileInput = (0, _labelable2.default)(_FileInput2.default);

var propTypes = {
  /* eslint-disable react/no-unused-prop-types */
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType,
  subpath: _pathHelpers.pathPropType,
  /* eslint-enable react/no-unused-prop-types */
  type: _propTypes2.default.string,
  value: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.instanceOf(File)), _propTypes2.default.string]),
  readOnly: _propTypes2.default.bool,
  typeInputLabel: _propTypes2.default.string,
  fileOptionLabel: _propTypes2.default.string,
  urlOptionLabel: _propTypes2.default.string,
  fileInputLabel: _propTypes2.default.string,
  fileChooseButtonLabel: _propTypes2.default.string,
  urlInputLabel: _propTypes2.default.string,
  formatFileInfo: _propTypes2.default.func,
  onCommit: _propTypes2.default.func,
  onTypeChanged: _propTypes2.default.func
};

var defaultProps = {
  type: 'file',
  typeInputLabel: 'Upload',
  fileOptionLabel: 'local file',
  urlOptionLabel: 'external media',
  fileInputLabel: 'File',
  fileChooseButtonLabel: undefined,
  urlInputLabel: 'URL',
  formatFileInfo: undefined
};

var UploadInput = function (_Component) {
  _inherits(UploadInput, _Component);

  function UploadInput(props) {
    _classCallCheck(this, UploadInput);

    var _this = _possibleConstructorReturn(this, (UploadInput.__proto__ || Object.getPrototypeOf(UploadInput)).call(this, props));

    _this.handleTypeInputCommit = _this.handleTypeInputCommit.bind(_this);
    _this.handleFileInputCommit = _this.handleFileInputCommit.bind(_this);
    _this.handleUrlInputCommit = _this.handleUrlInputCommit.bind(_this);

    _this.state = {
      type: props.type
    };
    return _this;
  }

  _createClass(UploadInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        type: nextProps.type
      });
    }
  }, {
    key: 'handleTypeInputCommit',
    value: function handleTypeInputCommit(path, value) {
      var prevValue = this.state.value;

      this.setState({
        type: value
      });

      var _props = this.props,
          onCommit = _props.onCommit,
          onTypeChanged = _props.onTypeChanged;


      if (onCommit) {
        onCommit((0, _pathHelpers.getPath)(this.props), null);
      }

      if (onTypeChanged && value !== prevValue) {
        onTypeChanged(value);
      }
    }
  }, {
    key: 'handleFileInputCommit',
    value: function handleFileInputCommit(path, value) {
      var onCommit = this.props.onCommit;


      if (onCommit) {
        onCommit((0, _pathHelpers.getPath)(this.props), value);
      }
    }
  }, {
    key: 'handleUrlInputCommit',
    value: function handleUrlInputCommit(path, value) {
      var onCommit = this.props.onCommit;


      if (onCommit) {
        onCommit((0, _pathHelpers.getPath)(this.props), value);
      }
    }
  }, {
    key: 'renderTypeInput',
    value: function renderTypeInput() {
      var _props2 = this.props,
          readOnly = _props2.readOnly,
          typeInputLabel = _props2.typeInputLabel,
          fileOptionLabel = _props2.fileOptionLabel,
          urlOptionLabel = _props2.urlOptionLabel;
      var type = this.state.type;


      var options = [{ value: 'file', label: fileOptionLabel }, { value: 'url', label: urlOptionLabel }];

      return _react2.default.createElement(DropdownMenuInput, {
        label: typeInputLabel,
        name: 'type',
        readOnly: readOnly,
        options: options,
        value: type,
        onCommit: this.handleTypeInputCommit
      });
    }
  }, {
    key: 'renderFileInput',
    value: function renderFileInput() {
      var _props3 = this.props,
          readOnly = _props3.readOnly,
          value = _props3.value,
          fileInputLabel = _props3.fileInputLabel,
          fileChooseButtonLabel = _props3.fileChooseButtonLabel,
          formatFileInfo = _props3.formatFileInfo;


      var fileList = value instanceof Array ? value : null;

      return _react2.default.createElement(FileInput, {
        label: fileInputLabel,
        name: 'file',
        readOnly: readOnly,
        value: fileList,
        chooseButtonLabel: fileChooseButtonLabel,
        formatFileInfo: formatFileInfo,
        onCommit: this.handleFileInputCommit
      });
    }
  }, {
    key: 'renderUrlInput',
    value: function renderUrlInput() {
      var _props4 = this.props,
          readOnly = _props4.readOnly,
          value = _props4.value,
          urlInputLabel = _props4.urlInputLabel;


      var externalUrl = typeof value === 'string' ? value : null;

      return _react2.default.createElement(TextInput, {
        label: urlInputLabel,
        name: 'url',
        readOnly: readOnly,
        value: externalUrl,
        onCommit: this.handleUrlInputCommit
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var type = this.state.type;


      var fileOrUrlInput = type === 'file' ? this.renderFileInput() : this.renderUrlInput();

      return _react2.default.createElement(
        'div',
        { className: _UploadInput2.default.common },
        this.renderTypeInput(),
        fileOrUrlInput
      );
    }
  }]);

  return UploadInput;
}(_react.Component);

exports.default = UploadInput;


UploadInput.propTypes = propTypes;
UploadInput.defaultProps = defaultProps;